View Javadoc

    1   /*
    2    * Licensed to the Apache Software Foundation (ASF) under one or more
    3    * contributor license agreements.  See the NOTICE file distributed with
    4    * this work for additional information regarding copyright ownership.
    5    * The ASF licenses this file to You under the Apache License, Version 2.0
    6    * (the "License"); you may not use this file except in compliance with
    7    * the License.  You may obtain a copy of the License at
    8    *
    9    *      http://www.apache.org/licenses/LICENSE-2.0
    10   *
    11   * Unless required by applicable law or agreed to in writing, software
    12   * distributed under the License is distributed on an "AS IS" BASIS,
    13   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    14   * See the License for the specific language governing permissions and
    15   * limitations under the License.
    16   */
    17
    18  package org.apache.log4j.pattern;
    19
    20
    21  /**
    22   *
    23   * Base class for other pattern converters which can return only parts of their name.
    24   *
    25   * @author Ceki G&uuml;lc&uuml;
    26   * @author Curt Arnold
    27   *
    28   */
    29  public abstract class NamePatternConverter
    30    extends LoggingEventPatternConverter {
    31    /**
    32     * Abbreviator.
    33     */
    34    private final NameAbbreviator abbreviator;
    35
    36    /**
    37     * Constructor.
    38     * @param name name of converter.
    39     * @param style style name for associated output.
    40     * @param options options, may be null, first element will be interpreted as an abbreviation pattern.
    41     */
    42    protected NamePatternConverter(
    43      final String name, final String style, final String[] options) {
    44      super(name, style);
    45
    46      if ((options != null) && (options.length > 0)) {
    47        abbreviator = NameAbbreviator.getAbbreviator(options[0]);
    48      } else {
    49        abbreviator = NameAbbreviator.getDefaultAbbreviator();
    50      }
    51    }
    52
    53    /**
    54     * Abbreviate name in string buffer.
    55     * @param nameStart starting position of name to abbreviate.
    56     * @param buf string buffer containing name.
    57     */
    58    protected final void abbreviate(final int nameStart, final StringBuffer buf) {
    59      abbreviator.abbreviate(nameStart, buf);
    60    }
    61  }